(function () {

  'use strict';

  var csInterface = new CSInterface();

  document.getElementById('btnSetAllMargins').addEventListener('click', function () {
    marginSizeAll=Number(marginsInputAll.value);
    if(isNaN(marginSizeAll)){marginSizeAll=0; marginsInputAll.value=marginSizeAll;}
    if(marginSizeAll<0){marginSizeAll=0; marginsInputAll.value=marginSizeAll;}   
    if(marginSizeAll>10000){marginSizeAll=10000; marginsInputAll.value=marginSizeAll;}
    marginsInputAll.value=marginSizeAll;  

    var marginSizeTop=marginSizeAll;
    marginsInputTop.value=marginSizeTop;

    var marginSizeBottom=marginSizeAll;
    marginsInputBottom.value=marginSizeBottom;

    var marginSizeLeft=marginSizeAll;
    marginsInputLeft.value=marginSizeLeft;

    var marginSizeRight=marginSizeAll;
    marginsInputRight.value=marginSizeRight;      
            
  });    
    
  document.getElementById('btnSelectInner').addEventListener('click', function () {
    validateInputs();
    csInterface.evalScript('makeSelectionInner("' + marginSizeTop + '","' + marginSizeBottom + '","' + marginSizeLeft + '","' + marginSizeRight + '")');
  });
    
  document.getElementById('btnSelectOuter').addEventListener('click', function () {
    validateInputs();  
    csInterface.evalScript('makeSelectionOuter("' + marginSizeTop + '","' + marginSizeBottom + '","' + marginSizeLeft + '","' + marginSizeRight + '")');
  });
    
  document.getElementById('btnInvert').addEventListener('click', function () {
    csInterface.evalScript('invertSelection()');
  });
    
  document.getElementById('btnDeselect').addEventListener('click', function () {
    csInterface.evalScript('deselect()');
  });
    
  document.getElementById('btnSmooth').addEventListener('click', function () {
    csInterface.evalScript('smooth()');
  });
    
  document.getElementById('btnFeather').addEventListener('click', function () {
    csInterface.evalScript('feather()');
  });   
    
  document.getElementById('btnFillBlack').addEventListener('click', function () {
    csInterface.evalScript('fillBlack()');
  });    
    
  document.getElementById('btnFillFG').addEventListener('click', function () {
    csInterface.evalScript('fillFG()');
  });
    
  document.getElementById('btnFillBG').addEventListener('click', function () {
    csInterface.evalScript('fillBG()');
  });    
    
  document.getElementById('btnFillWhite').addEventListener('click', function () {
    csInterface.evalScript('fillWhite()');
  });    
    
  document.getElementById('btnFillGray').addEventListener('click', function () {
    csInterface.evalScript('fillGray()');
  });   
    
  document.getElementById('btnFillMenu').addEventListener('click', function () {
    csInterface.evalScript('fill()');
  });  
    
function validateInputs(){
    
    marginSizeAll=Math.round(Number(marginsInputAll.value));
    if(isNaN(marginSizeAll)){marginSizeAll=0;}
    if(marginSizeAll<0){marginSizeAll=0;}   
    if(marginSizeAll>10000){marginSizeAll=10000;}
    marginsInputAll.value=marginSizeAll;

    if (marginsInputTop.value==""){marginSizeTop=marginSizeAll;}
    else{marginSizeTop=Math.round(Number(marginsInputTop.value));}
    if(isNaN(marginSizeTop)){marginSizeTop=0;}
    if(marginSizeTop<0){marginSizeTop=0;}   
    if(marginSizeTop>10000){marginSizeTop=10000;}
    marginsInputTop.value=marginSizeTop;
    
    if (marginsInputBottom.value==""){marginSizeBottom=marginSizeAll;}
    else{marginSizeBottom=Math.round(Number(marginsInputBottom.value));}
    if(isNaN(marginSizeBottom)){marginSizeBottom=0;}
    if(marginSizeBottom<0){marginSizeBottom=0;}   
    if(marginSizeBottom>10000){marginSizeBottom=10000;}
    marginsInputBottom.value=marginSizeBottom;     
     
    if (marginsInputLeft.value==""){marginSizeLeft=marginSizeAll;}
    else{marginSizeLeft=Math.round(Number(marginsInputLeft.value));}
    if(isNaN(marginSizeLeft)){marginSizeLeft=0;}
    if(marginSizeLeft<0){marginSizeLeft=0;}   
    if(marginSizeLeft>10000){marginSizeLeft=10000;}
    marginsInputLeft.value=marginSizeLeft;     

    if (marginsInputRight.value==""){marginSizeRight=marginSizeAll;}
    else{marginSizeRight=Math.round(Number(marginsInputRight.value));}
    if(isNaN(marginSizeRight)){marginSizeRight=0;}
    if(marginSizeRight<0){marginSizeRight=0;}   
    if(marginSizeRight>10000){marginSizeRight=10000;}
    marginsInputRight.value=marginSizeRight;     
    
}    

}());

